<template>
  <div class="login-form">
    <div class="login-header">
      <h6>Зарегистрированный Пользователь</h6>
      <p>Войти в систему для быстрого доступа и удобного оформления заказа.</p>
    </div>

    <div v-show="!forgotForm">
      <div class="form-group">
        <label for="email">EMAIL</label>
        <input type="text" class="main-input" :class="{'invalid': checkRequired(loginUser.email)}" v-model="loginUser.email" name="email">
      </div>

      <div class="form-group">
        <label for="password">ПАРОЛЬ</label>
        <input type="password" class="main-input" :class="{'invalid': checkRequired(loginUser.password)}" v-model="loginUser.password" name="password">
      </div>
    </div>

    <div v-show="forgotForm">
      <div class="form-group">
        <label for="email">EMAIL</label>
        <input type="text" class="main-input" :class="{'invalid': checkRequired(forgotDetails.email)}" v-model="forgotDetails.email" name="email">
      </div>
    </div>
    <p v-show="!forgotForm" class="text-right forgot-pw" @click="showForgot" >Забыли пароль ?</p>
    <p class="errorMessage" v-if="error" v-text="error"></p>
    <button v-show="!forgotForm" class="action-button black-button" @click="login">ВОЙТИ</button>
    <button v-show="forgotForm" class="action-button black-button" @click="submitForgot">ВОССТАНОВИТЬ</button>

    <modal :header="'Forgot Password'" :isShow="showModal" v-if="showModal" @close="showModal = false">
      <div slot="body">
        <p>Мы отправили инструкции по восстановлению пароля на ваш email. Пожалуйста, перейдите по ссылке в письме.</p>
        <button class="ok-button action-button gray-button pull-right" @click="showModal = false;">OK</button>
        
      </div>

      <div slot="footer">
        
      </div>
    </modal>
  </div>
</template>
<script>
import {mapMutations} from 'vuex';
import Modal from "../shared/Modal";
export default {
  data() {
    return {
      error: '',
      loginUser: {
        'email': '',
        'password': ''
      },
      forgotDetails: {
        'email': ''
      },
      showRequired: false, forgotForm: false, showModal: false
    }
  },
  components: {
    Modal
  },
  methods: {
    ...mapMutations(["ADD_LOGGED_USER"]),
    login(e) {
      this.error = '';
      this.showRequired = false;
      if (!this.loginUser.email || !this.loginUser.password) {
        this.showRequired = true;
        return this.error = 'Пожалуйста, заполните обязательные поля.'
      }
      e.target.disabled = true;
      this.$http
        .post(`${process.env.VUE_APP_BASE_URL}/login`, this.loginUser)
        .then(response => {
          this.ADD_LOGGED_USER(response.data);
          this.$router.push(this.$route.query.from || "/");
        })
        .catch(error => {
          e.target.disabled = false;
          this.error = 'Невереные данные пользователя.';
        });
    },
    checkRequired(i) {
      return this.showRequired && !i;
    },
    showForgot() {
      this.forgotForm = true;
    },
    submitForgot(e) {
      this.error = '';
      this.showRequired = false;
      if (!this.forgotDetails.email) {
        this.showRequired = true;
        return this.error = 'Пожалуйста, заполните обязательные поля.';
      }
      e.target.disabled = true;
      this.$http
        .post(`${process.env.VUE_APP_BASE_URL}/forgot-password`, this.forgotDetails)
        .then(response => {
          this.showModal = true;
          this.forgotDetails.email = '';
          this.showForgot = false;
        })
        .catch(error => {
          e.target.disabled = false;
          this.error = 'Произошла ошибка.';
        });
    }
  }
}


</script>